<%@ WebService Language="C#" Class="Countrieservice" %>

using System;
using System.IO;
using System.Xml;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using System.Web.Script.Services;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[ScriptService]
public class Countrieservice  : System.Web.Services.WebService {

    [WebMethod]
    public string[] GetCountries(string prefixText, int count) 
    {
        return GetCountriesFromXml(prefixText, count);
    }

    private string[] GetCountriesFromXml(string prefixText, int count)
    {
        List<string> suggestions = new List<string>();
        
        using (XmlTextReader reader = new XmlTextReader(HttpContext.Current.Server.MapPath("~/App_Data/Countries.xml")))
        {
            while (reader.Read())
            {
                if (reader.NodeType == XmlNodeType.Element && reader.Name == "Country")
                {
                    string CountryName = reader.ReadInnerXml();

                    if (CountryName.StartsWith(prefixText, StringComparison.InvariantCultureIgnoreCase))
                    {
                        suggestions.Add(CountryName);

                        if (suggestions.Count == count) break;
                    }
                }
            }
        }

        return suggestions.ToArray();
    }
}

